/*
  Fibotest
  fibo(46) 
  P2 200MHz FlexProp 100 Durchläufe local: int a, b, c, i; uses fcache 571 µs ==> 5.7µs 
  P2 200MHz FlexProp 100 Durchläufe global: int a, b, c, i; uses fcache 3362 µs ==> 33.62µs 

  P2 200MHz FlexProp 100 Durchläufe local: int a, b, c, i; no Optim. no fcache: 963 µs ==>  9.63µs 
  P2 200MHz FlexProp 100 Durchläufe global: int a, b, c, i; no Optim. no fcache: 4787 µs ==>  47.87µs 

*/

enum { _xtlfreq = 20_000_000 } ;
enum {    _clkfreq = 200_000_000 } ;
enum {    DOWNLOAD_BAUD = 230_400 } ;
enum {    DEBUG_BAUD = 230_400 } ;


#include <stdio.h>

//int a, b, c, i; // Global Hub variables

int fibo(int n)
{
  int a, b, c, i; // Local Cog Variables
  a=0; b=1; 
  for(i=0; i<(n-1); i++)
  {
    c= a+b;
    a=b;
    b=c;
  }
  return c;
}

// the setup routine runs once when you press reset:
void setup() {
  unsigned int starttime, endtime;
  int erg;

  //delay(200);
  //Serial.begin(115200);     // Open serial communications:
  //delay(100);

  starttime=_cnt();
//  for(int i=0; i<100; i++)
//  {
    erg= fibo(46);
//  }
  endtime=_cnt();
  printf("\nFibonacci(46): %d ",erg);
  printf(" Completed in %d ns\n",_muldiv64(endtime-starttime, 1_000_000_000, _clockfreq()));
}

// the loop routine runs over and over again forever:
void loop() {
  while(1);
  //delay(1);        
}

void main() {
   setup();
   loop();
}
